// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlRadioBox")]
    pub struct RadioBox(Object<ffi::DzlRadioBox, ffi::DzlRadioBoxClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_radio_box_get_type(),
    }
}

impl RadioBox {
    pub const NONE: Option<&'static RadioBox> = None;

    #[doc(alias = "dzl_radio_box_new")]
    pub fn new() -> RadioBox {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_radio_box_new()).unsafe_cast() }
    }
}

impl Default for RadioBox {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::RadioBox>> Sealed for T {}
}

pub trait RadioBoxExt: IsA<RadioBox> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_radio_box_add_item")]
    fn add_item(&self, id: &str, text: &str) {
        unsafe {
            ffi::dzl_radio_box_add_item(
                self.as_ref().to_glib_none().0,
                id.to_glib_none().0,
                text.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_radio_box_get_active_id")]
    #[doc(alias = "get_active_id")]
    fn active_id(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_radio_box_get_active_id(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_radio_box_remove_item")]
    fn remove_item(&self, id: &str) {
        unsafe {
            ffi::dzl_radio_box_remove_item(self.as_ref().to_glib_none().0, id.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_radio_box_set_active_id")]
    fn set_active_id(&self, id: &str) {
        unsafe {
            ffi::dzl_radio_box_set_active_id(self.as_ref().to_glib_none().0, id.to_glib_none().0);
        }
    }

    #[doc(alias = "has-more")]
    fn has_more(&self) -> bool {
        ObjectExt::property(self.as_ref(), "has-more")
    }

    #[doc(alias = "show-more")]
    fn shows_more(&self) -> bool {
        ObjectExt::property(self.as_ref(), "show-more")
    }

    #[doc(alias = "show-more")]
    fn set_show_more(&self, show_more: bool) {
        ObjectExt::set_property(self.as_ref(), "show-more", show_more)
    }

    #[doc(alias = "changed")]
    fn connect_changed<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn changed_trampoline<P: IsA<RadioBox>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlRadioBox,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(RadioBox::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"changed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    changed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "active-id")]
    fn connect_active_id_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_active_id_trampoline<P: IsA<RadioBox>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlRadioBox,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(RadioBox::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::active-id\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_active_id_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "has-more")]
    fn connect_has_more_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_has_more_trampoline<P: IsA<RadioBox>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlRadioBox,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(RadioBox::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::has-more\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_has_more_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-more")]
    fn connect_show_more_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_more_trampoline<P: IsA<RadioBox>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlRadioBox,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(RadioBox::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-more\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_more_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<RadioBox>> RadioBoxExt for O {}

impl fmt::Display for RadioBox {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("RadioBox")
    }
}
